#include "list.h"

void MyDictionary::insertNode(string what2insert){
	insert(what2insert,&head);
}


void MyDictionary::delNode(string what2del){
	try{
		del(what2del,&head);
	}catch(Except & e){
		cout << e.message << endl;
	}
}

void MyDictionary::printList(){
	print(head.down,"",false);
}

void MyDictionary::searchAll(string what2search){
	if(search(head.down,what2search))
		cout << "YA FOUND!" << endl;
	else
		cout << "NOPE NOT FOUND!" << endl;
}

MyDictionary::MyDictionary(const char * path)
{
	FILE* in;
	if(!(in = fopen(path,"r"))){
		throw Except("FILE NOT FOUND!");
		return;
	}

	
	// Instantiating a dictionary objetc

	int num;
	fscanf(in,"%d",&num);

	for ( int i = 0;i<num;i++)
	{
		char Buffer  [100];
		fscanf(in,"%s",Buffer);
		string temp( Buffer);
		insertNode( temp);
	}

	fclose(in);
}

MyDictionary::MyDictionary(){
}

MyDictionary::~MyDictionary()
{
	delete4des(head.down);
}

Node * MyDictionary::goToEnd(string what2insert){
	Node * mylist = new Node('0');
	Node * indicator = mylist;
	int end = what2insert.length();

	for(int count = 0;count < end;count++){
		indicator->next = new Node(what2insert[count]);
		indicator = indicator->next;
	}

	return mylist;
}

void MyDictionary::rearrange(Node * where){
	where->next = where->down->next;
	Node * tmp = where->down;
	where->down = where->down->down;
	delete tmp;
}

void MyDictionary::insert(string what2insert,Node * where){
	if(where->next != NULL  && where->next->data == what2insert[0]){
		insert(string(what2insert,1,what2insert.length() - 1),where->next);
		return;
	}
	//else

	if (where->down == NULL){
		where->down = goToEnd(what2insert);
		return;
	}
	//else

	insert(what2insert,where->down);
}



bool MyDictionary::del(string what2del,Node * where) {
/********************************************************************************************/
	if(what2del.length() != 0)
	{
		if(where->down == NULL && (where->next == NULL || what2del[0] != where->next->data))
			throw Except("NOT FOUND!!!");
	}
	else if(where->down == NULL && where->next != NULL)
		throw Except("NOT FOUND!!!");
/********************************************************************************************/
	if(what2del.length() == 0)
	{
		if(where->next == NULL)
		{
			if(where->down == NULL)
				return true;
			//else

			rearrange(where);
		}else
		{
			if(del(what2del,where->down))
			{
				delete where->down;
				where->down = NULL;
			}
		}
	}else
	{
		if(where->next == NULL || where->next->data != what2del[0])
		{
			if(del(what2del,where->down))
			{
				delete where->down;
				where->down = NULL;
			}
		}else{
			if(del(string(what2del,1,(what2del.length() - 1)),where->next))
			{
				delete where->next;
				where->next = NULL;

				if(where->down == NULL) 
					return true;
				//else

				rearrange(where);
			}
		}
	}

	return false;
}

void MyDictionary:: print( Node* where, string buffer, bool direction)
{
	if(direction)
		buffer += where->data;
	
	if ( where->next == NULL ) 
		cout << buffer << endl;
	else
		print(where->next,buffer,true);

	if(where->down != NULL)
		print(where->down,buffer,false);
}

bool MyDictionary::search(Node * where,string what2search){
	if(where == NULL)//for down that is null
		return false;

	if(what2search.length() == 0)
		return (where->next == NULL || search(where->down,""));
	else
		return search(where->down,what2search)|| search(where->next,string(what2search,1,what2search.length() - 1));
}

void MyDictionary::delete4des(Node * where){
	if(where == NULL)
		return;

	if(where->next == NULL && where->down == NULL)
		delete where;
	else{ 
		if(where->next != NULL)
			delete4des(where->next);
		if(where->down != NULL)
			delete4des(where->down);
		delete where;
	}
}

